unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, StrUtils, Buttons, ComCtrls, CAPICOM_TLB;

type
  TformCertificados = class(TForm)
    lsCertificados: TListBox;
    LWEB: TLabel;
    Label1: TLabel;
    bSalir: TButton;
    btObtenerDatosCertificados: TBitBtn;
    btGuardarDatos: TBitBtn;
    dlGuardar: TSaveDialog;
    btObtenerCertificados: TBitBtn;
    StatusBar1: TStatusBar;
    procedure LWEBClick(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
    procedure btObtenerDatosCertificadosClick(Sender: TObject);
    procedure btGuardarDatosClick(Sender: TObject);
    procedure btObtenerCertificadosClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formCertificados: TformCertificados;

implementation

{$R *.dfm}

function SiNo (valor : Boolean) : string;
begin
  if valor then
    Result := 'S'
  else
    Result := 'No';
end;

function obtenerNombreCertificado (nombre : string) : string;
var
  nombreR : string;
begin
  nombreR := AnsiReplaceStr(nombre, 'CN=NOMBRE',  '');
  nombreR := AnsiReplaceStr(nombre, 'NOMBRE',  '');
  nombreR := Trim (copy(nombreR, 1, pos(' - NIF', nombreR) - 1));
  Result := nombreR;
end;

function obtenerNombreNIFCertificado (nombre : string) : string;
var
  nombreR : string;
begin
  nombreR := AnsiReplaceStr(nombre, 'CN=NOMBRE',  '');
  nombreR := AnsiReplaceStr(nombre, 'NOMBRE',  '');
  Result := nombreR;
end;


procedure TformCertificados.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformCertificados.bSalirClick(Sender: TObject);
begin
  close;
end;

procedure TformCertificados.btObtenerDatosCertificadosClick(Sender: TObject);
const
  CAPICOM_CA_STORE = 'ca';
  CAPICOM_MY_STORE = 'my';
  CAPICOM_ADDRESS_BOOK_STORE = 'AddressBook';
  CAPICOM_OTHER_STORE = 'other';
  CAPICOM_ROOT_STORE = 'root';
var
    carpetaAlmacen : IStore;
    certificadosAlmacen : ICertificates;
    certificadoActual : ICertificate2;
    i, j: integer;
begin
  lsCertificados.Clear;

  carpetaAlmacen := CoStore.Create;
  carpetaAlmacen.Open(CAPICOM_CURRENT_USER_STORE,
      CAPICOM_MY_STORE, CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED or
      CAPICOM_STORE_OPEN_INCLUDE_ARCHIVED or
      CAPICOM_STORE_OPEN_EXISTING_ONLY);
   certificadosAlmacen := carpetaAlmacen.Certificates as ICertificates2;
  for i := 1 to certificadosAlmacen.Count do
  begin
    certificadoActual :=
        IInterface(certificadosAlmacen.Item[i]) as ICertificate2;

    lsCertificados.Items.Add('--------------------------------------');
    lsCertificados.Items.Add (obtenerNombreNIFCertificado(
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_SIMPLE_NAME)));
    lsCertificados.Items.Add('--------------------------------------');

    lsCertificados.Items.Add ('     NOMBRE: ' +
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_SIMPLE_NAME));

    lsCertificados.Items.Add ('     EMITIDO POR: ' +
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_ISSUER_SIMPLE_NAME));

    lsCertificados.Items.Add ('     EMAIL: ' +
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_EMAIL_NAME));

    lsCertificados.Items.Add ('     FECHA EMISIN: ' +
        DateTimeToStr(certificadoActual.ValidFromDate));

    lsCertificados.Items.Add ('     FECHA EXPIRACIN: ' +
        DateTimeToStr(certificadoActual.ValidToDate));

    lsCertificados.Items.Add ('     NMERO DE SERIE: ' +
        certificadoActual.SerialNumber);

    lsCertificados.Items.Add ('     SHA1 HASH: ' +
        certificadoActual.Thumbprint);

    lsCertificados.Items.Add ('     NOMBRE DNS: ' +
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_DNS_NAME));

    lsCertificados.Items.Add ('     NOMBRE UPN: ' +
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_UPN));

    if certificadoActual.Archived then
      lsCertificados.Items.Add ('     ARCHIVADO: S')
    else
      lsCertificados.Items.Add ('     ARCHIVADO: NO');

    if certificadoActual.BasicConstraints.IsPresent then
    begin
      if certificadoActual.BasicConstraints.IsCritical then
        lsCertificados.Items.Add ('     CRTICO: S')
      else
        lsCertificados.Items.Add ('     CRTICO: NO');
      if certificadoActual.BasicConstraints.IsCertificateAuthority then
        lsCertificados.Items.Add ('     AUTORIDAD DE CERTIFICACIN: S')
      else
        lsCertificados.Items.Add ('     AUTORIDAD DE CERTIFICACIN: NO');

      if certificadoActual.BasicConstraints.IsPathLenConstraintPresent then
         lsCertificados.Items.Add (
             inttostr(certificadoActual.BasicConstraints.PathLenConstraint))
      else
         lsCertificados.Items.Add ('     RESTRICCIN PATHLENCONSTRAINT NO PRESENTE');
    end
    else
      lsCertificados.Items.Add ('     RESTRICCIONES BSICAS NO PRESENTES');

    if certificadoActual.KeyUsage.IsPresent then
    begin
      lsCertificados.Items.Add ('     USO DE CLAVES:');
      lsCertificados.Items.Add ('          Critical = ' +
          SiNo (certificadoActual.KeyUsage.IsCritical));
      lsCertificados.Items.Add ('          IsDigitalSignatureEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsDigitalSignatureEnabled));
      lsCertificados.Items.Add ('          IsNonRepudiationEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsNonRepudiationEnabled));
      lsCertificados.Items.Add ('          IsKeyEnciphermentEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsKeyEnciphermentEnabled));
      lsCertificados.Items.Add ('          IsDataEnciphermentEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsDataEnciphermentEnabled));
      lsCertificados.Items.Add ('          IsKeyAgreementEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsKeyAgreementEnabled));
      lsCertificados.Items.Add ('          IsKeyCertSignEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsKeyCertSignEnabled));
      lsCertificados.Items.Add ('          IsCRLSignEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsCRLSignEnabled));
      lsCertificados.Items.Add ('          IsEncipherOnlyEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsEncipherOnlyEnabled));
      lsCertificados.Items.Add ('          IsDecipherOnlyEnabled = ' +
          SiNo (certificadoActual.KeyUsage.IsDecipherOnlyEnabled));
    end
    else
     lsCertificados.Items.Add ('     USO DE CLAVES: NO PRESENTE');

    if certificadoActual.ExtendedKeyUsage.IsPresent then
      lsCertificados.Items.Add ('     USO DE CLAVE EXTENDIDO: PRESENTE')
    else
      lsCertificados.Items.Add ('     USO DE CLAVE EXTENDIDO: NO PRESENTE');


    if certificadoActual.Template.IsPresent Then
    begin
      lsCertificados.Items.Add ('     PLANTILLA:');
      lsCertificados.Items.Add ('          Critical = ' +
          BoolToStr (certificadoActual.Template.IsCritical));
      lsCertificados.Items.Add ('          Nombre = ' +
          certificadoActual.Template.Name);
      lsCertificados.Items.Add ('          OID = ' +
          certificadoActual.Template.OID.FriendlyName + ' (' +
              certificadoActual.Template.OID.Value + ')');
      lsCertificados.Items.Add ('          Mayor = ' +
          IntToStr(certificadoActual.Template.MajorVersion));
      lsCertificados.Items.Add ('          Menor = ' +
          IntToStr(certificadoActual.Template.MinorVersion));
    end
    else
      lsCertificados.Items.Add ('     TEMPLATE: NO PRESENTE');


    lsCertificados.Items.Add ('     CLAVE PBLICA:');
    lsCertificados.Items.Add ('          Algoritmo = ' +
        certificadoActual.PublicKey.Algorithm.FriendlyName + ' (' +
        certificadoActual.PublicKey.Algorithm.Value + ')');
    lsCertificados.Items.Add ('          Tamao = ' +
        IntToStr (certificadoActual.PublicKey.Length) + ' bits');

    if certificadoActual.HasPrivateKey then
    begin
      lsCertificados.Items.Add ('     CLAVE PRIVADA:');
      lsCertificados.Items.Add ('          Nombre del contenedor = ' +
         certificadoActual.PrivateKey.ContainerName);
      lsCertificados.Items.Add ('          Nombre nico = ' +
         certificadoActual.PrivateKey.UniqueContainerName);
      lsCertificados.Items.Add ('          Nombre del proveedor = ' +
         certificadoActual.PrivateKey.ProviderName);
      lsCertificados.Items.Add ('          Accessible = ' +
         SiNo (certificadoActual.PrivateKey.IsAccessible));
      lsCertificados.Items.Add ('          Protegida = ' +
         SiNo (certificadoActual.PrivateKey.IsProtected));
      lsCertificados.Items.Add ('          Exportable =  ' +
         SiNo (certificadoActual.PrivateKey.IsExportable));
      lsCertificados.Items.Add ('          Eliminable = ' +
         SiNo (certificadoActual.PrivateKey.IsRemovable));
      lsCertificados.Items.Add ('          Keyset equipo = ' +
         SiNo (certificadoActual.PrivateKey.IsMachineKeyset));
      lsCertificados.Items.Add ('          Almacn Hardware = ' +
         SiNo (certificadoActual.PrivateKey.IsHardwareDevice));
    end
    else
      lsCertificados.Items.Add ('     CLAVE PRIVADA NO ENCONTRADA');

    if i < certificadosAlmacen.Count then
    begin
      lsCertificados.Items.Add('');
      lsCertificados.Items.Add('');
    end;
  end;
end;

procedure TformCertificados.btGuardarDatosClick(Sender: TObject);
begin
  dlGuardar.Title :=
      'Guardar datos de certificados digitales en fichero';
  dlGuardar.Filter :=
      'Ficheros de texto (*.txt)|*.txt|Todos los ficheros (*.*)|*.*';
  dlGuardar.FileName := 'certificados';
  dlGuardar.DefaultExt := 'txt';
  if dlGuardar.Execute then
    lsCertificados.Items.SaveToFile(dlGuardar.FileName);
end;

procedure TformCertificados.btObtenerCertificadosClick(Sender: TObject);
const
  CAPICOM_CA_STORE = 'ca';
  CAPICOM_MY_STORE = 'my';
  CAPICOM_ADDRESS_BOOK_STORE = 'AddressBook';
  CAPICOM_OTHER_STORE = 'other';
  CAPICOM_ROOT_STORE = 'root';
var
    carpetaAlmacen : IStore;
    certificadosAlmacen : ICertificates;
    certificadoActual : ICertificate2;
    i, j: integer;
begin
  lsCertificados.Clear;
  carpetaAlmacen := CoStore.Create;
  carpetaAlmacen.Open(CAPICOM_CURRENT_USER_STORE,
      CAPICOM_MY_STORE, CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED or
      CAPICOM_STORE_OPEN_INCLUDE_ARCHIVED or
      CAPICOM_STORE_OPEN_EXISTING_ONLY);
  certificadosAlmacen := carpetaAlmacen.Certificates as ICertificates2;
  for i := 1 to certificadosAlmacen.Count do
  begin
    certificadoActual :=
        IInterface(certificadosAlmacen.Item[i]) as ICertificate2;
    lsCertificados.Items.Add (obtenerNombreNIFCertificado(
        certificadoActual.GetInfo (CAPICOM_CERT_INFO_SUBJECT_SIMPLE_NAME)));
  end;
end;

end.
